<template>
  <el-row v-loading="loading">
    <template v-if="routeForm && routeForm.id">
      <el-col :span="24">
        <el-page-header @back="$router.go(-1)" content="Route info:">
        </el-page-header>
        Way from-to:
        <h4>{{ routeForm.cityA + " - " + routeForm.cityB }}</h4>
        Distance, km:
        <h4>{{ routeForm.distance }}</h4>
        Expected revenue, $:
        <h4>{{ routeForm.expected_revenue }}</h4>

        Car type:
        <h4>{{ routeForm.car_type_id == 0 ? "Passenger" : "Freight" }}</h4>
        <el-button @click="$router.push({ name: 'EditRoute', params: { id } })"
          >Edit</el-button
        >
        <el-button type="danger" @click="handleDeleteRoute">Delete</el-button>
      </el-col>
      <el-col :gutter="3" :span="12" v-if="route_car && route_car.id">
        <el-divider></el-divider>
        <h3>Car info:</h3>

        <span>Reg. number:</span>
        <h4>{{ route_car.registration_mark }}</h4>

        <span>Mileage, mi:</span>
        <h4>{{ route_car.mileage }}</h4>
        <span>Purchase date:</span>
        <h4>{{ $moment(route_car.purchase_date).format('YYYY-MM-DD') }}</h4>
        <span>Car type:</span>
        <h4>{{ route_car.car_type_id == 0 ? "Passenger" : "Freight" }}</h4>
      </el-col>
      <el-col v-else>
        <el-divider></el-divider>
        This route doesn't have assigned car.
        <el-link
          type="primary"
          @click="
            $router.push({ name: 'EditRoute', params: { id, fromLink: true } })
          "
          >Add car here.</el-link
        >
      </el-col>
    </template>
    <el-col v-else-if="!loading">
      Not found route with id: <b>{{ id }}</b>
    </el-col>
    <el-col v-else> Loading... </el-col>
  </el-row>
</template>

<script>
  import routeModelMixin from "@/mixins/routeModelMixin";
  import { mapActions } from "vuex";
  import { ACTIONS_DELETE_ROUTE } from "@/plugins/constants";

  export default {
    mixins: [routeModelMixin],
    methods: {
      ...mapActions({ ACTIONS_DELETE_ROUTE }),

      handleDeleteRoute() {
        this.ACTIONS_DELETE_ROUTE(this.id)
          .then((_) => {
            this.$router.push({ name: "Routes" });
            this.$notify.success({ message: "Successfully deleted record" });
          })
          .catch(({ response }) =>
            this.$notify.error({ message: response.data })
          );
      },
    },
  };
</script>

<style scoped>
  h4 {
    margin-top: 0px !important;
  }
</style>